Loading...
Searching...
No Matches
oscore_crypto.h File Reference

An implementation of the Hash Based Key Derivation Function (RFC) and wrappers for AES-CCM*. More...

`#include <coap3/coap_internal.h>`
Include dependency graph for oscore_crypto.h:

Go to the source code of this file.

## Macros

#define | HKDF_INFO_MAXLEN 25
#define | HKDF_OUTPUT_MAXLEN 25
#define | AES_CCM_TAG 8
#define | AEAD_PLAINTEXT_MAXLEN COAP_MAX_CHUNK_SIZE
#define | AEAD_TAG_MAXLEN COAP_MAX_CHUNK_SIZE

## Functions

int | oscore_hmac_hash (cose_hmac_alg_t hmac_alg, coap_bin_const_t *key, coap_bin_const_t *data, coap_bin_const_t **hmac)
| Derive the hmac hash using HMAC-HASH() function.
int | oscore_hkdf_extract (cose_hkdf_alg_t hkdf_alg, coap_bin_const_t *salt, coap_bin_const_t *ikm, coap_bin_const_t **hkdf_extract)
| Derive the pseudorandom key using HKDF-Extract() function.
int | oscore_hkdf_expand (cose_hkdf_alg_t hkdf_alg, coap_bin_const_t *prk, uint8_t *info, size_t info_len, uint8_t *okm, size_t okm_len)
| Derive the key using HKDF-Expand() function.
int | oscore_hkdf (cose_hkdf_alg_t hkdf_alg, coap_bin_const_t *salt, coap_bin_const_t *ikm, uint8_t *info, size_t info_len, uint8_t *okm, size_t okm_len)
| Derive the key using HKDF() function.

## Detailed Description

An implementation of the Hash Based Key Derivation Function (RFC) and wrappers for AES-CCM*.

Author
  Martin Gunnarsson marti.nosp@m.n.gu.nosp@m.nnars.nosp@m.son@.nosp@m.ri.se

adapted to libcoap Peter van der Stok consu.nosp@m.ltan.nosp@m.cy@va.nosp@m.nder.nosp@m.stok..nosp@m.org on request of Fairhair alliance adapted for libcoap integration Jon Shallow supjp.nosp@m.s-li.nosp@m.bcoap.nosp@m.@jps.nosp@m.hallo.nosp@m.w.co.nosp@m.m

Definition in file oscore_crypto.h.